Description

Make it easy to "adjoin" indets to a poly ring.

JAA thinks this means: given polyring QQ[x,y] and new indets a,b

create polyring QQ[x,y,a,b]

create embedding QQ[x,y] into QQ[x,y,a,b] -- just a PolyAlgHom

create "inverse" hom from QQ[x,y,a,b] into QQ[x,y]

put everything together into a convenient structure

make it accessible from CoCoA-5

Requested by Julian Danner

Related issues:

Related to CoCoALib - Feature #992: Poly ring homomorphism to change ordering New 13 Dec 2016

Related to CoCoALib - Feature #562: Subrings New 20 May 2014

History

#1 - 25 Jun 2020 05:33 - John Abbott

Description above is incomplete:

what term ord on QQ[x,y,a,b]?  For impl, it would be nice if the orderings were compatible (i.e. respected by the embedding)

can the new indets be indexed?  e.g. QQ[x,y,a[1..2]]

what should the "inverse" hom do when applied to something outside the image of QQ[x,y]?

the convenient structure could be just a pair of RingHoms; or should the big ring be available as a field of the record?

KISS suggests making the "inverse" send all new indets to 0; it is then the caller's responsibility to ensure that it is applied only to values in the image

(assume that this check is wanted).

SUGGESTION should the embedding be available to CanonicalHom?  That would be nice!  How to achieve this?  (probably a new issue)

#2 - 25 Jun 2020 06:22 - John Abbott

- Related to Feature #992: Poly ring homomorphism to change ordering added

#3 - 29 Sep 2020 13:12 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

What should new indets be called?  Should they be "new symbols"?  Advantage is that there could be no problems with name clashes.

Where should the new indets appear relative to those already in the poly ring?
At least for a first impl, they could appear after the indets of the orig ring (at least by default).

The embedding hom is one which respects PPs  (i.e. the image of a PP is a PP).  The inverse almost respects PPs too (unless they map to 0); if the

inverse hom maps the new indets to 1 then the inv hom does respect PPs (but is obviously not injective if applied to elems outside the image of the

embedding).

REMINDER this does remind me that I was considering introducing certain types of subring (see #562) so that homs could be restricted to them. 

They could be useful in this context.

#4 - 29 Sep 2020 13:12 - John Abbott

- Related to Feature #562: Subrings added

#5 - 15 Feb 2024 22:45 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99900
